#---------------------------------------------------------------------------------------------------
# %L                                                                                               -
# u-print                                                                                          -
# %%                                                                                               -
# Copyright (C) 2016 - 2018 République et Canton de Genève                                         -
# %%                                                                                               -
# This program is free software: you can redistribute it and/or modify                             -
# it under the terms of the GNU Affero General Public License as published by                      -
# the Free Software Foundation, either version 3 of the License, or                                -
# (at your option) any later version.                                                              -
#                                                                                                  -
# This program is distributed in the hope that it will be useful,                                  -
# but WITHOUT ANY WARRANTY; without even the implied warranty of                                   -
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the                                     -
# GNU General Public License for more details.                                                     -
#                                                                                                  -
# You should have received a copy of the GNU Affero General Public License                         -
# along with this program. If not, see <http://www.gnu.org/licenses/>.                             -
# L%                                                                                               -
#---------------------------------------------------------------------------------------------------

services:
  - docker:dind

variables:
  DOCKER_DRIVER: overlay
  MAVEN_REPO_OPTS: "-Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository --settings=$CI_PROJECT_DIR/settings.xml"

stages:
  - build-artifact
  - deploy

artifact:application:
  image: $IMAGE_MVN_JDK11
  stage: build-artifact
  script:
    - mvn -B $MAVEN_REPO_OPTS clean $SONAR_PRE_BUILD_CMD install -P\!linux,windows $SONAR_POST_BUILD_CMD
  artifacts:
    expire_in: 1 week
    paths:
      - u-print-business/target/*.jar
      - u-pring-business/target/site/
      - u-print-gui/target/*.jar
      - u-pring-gui/target/site/
      - .m2/repository/
  cache:
    key: u-print-$CI_COMMIT_REF_NAME
    paths:
      - .m2/repository/

windows-zip:
  image: $IMAGE_MVN_JDK11
  stage: deploy
  dependencies:
    - artifact:application
  script:
    - cd u-print-gui
    - apt-get install -y curl unzip
    - curl -L 'https://api.adoptopenjdk.net/v2/binary/releases/openjdk11?openjdk_impl=hotspot&os=windows&arch=x64&release=latest&type=jre' --output openjdk11.zip
    - mkdir java
    - unzip openjdk11.zip -d java
    - mv java/jdk* java/jre
    # Remove unused files
    - rm openjdk11.zip
    - mvn -B $MAVEN_REPO_OPTS assembly:single
    - cp target/*.zip ../
  artifacts:
    when: always
    paths:
      - u-print-*.zip
